/***************************************************************
 * Name:      App_ArchivioMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    prof. Giuseppe Sportelli ()
 * Created:   2020-04-21
 * Copyright: prof. Giuseppe Sportelli (https://www.giuseppesportelli.it)
 * License:
 **************************************************************/

#include "App_ArchivioMain.h"
#include <wx/msgdlg.h>
#include <fstream>
using namespace std;
//(*InternalHeaders(App_ArchivioFrame)
#include <wx/string.h>
#include <wx/intl.h>
//*)

struct a
{
    string cognome;
    string nome;
    string classe;
    string sezione;
    string data;
};
//helper functions
a alunno;
enum wxbuildinfoformat {
    short_f, long_f };
fstream file;
wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(App_ArchivioFrame)
const long App_ArchivioFrame::ID_STATICTEXT1 = wxNewId();
const long App_ArchivioFrame::ID_TEXTCTRL1 = wxNewId();
const long App_ArchivioFrame::ID_STATICTEXT2 = wxNewId();
const long App_ArchivioFrame::ID_TEXTCTRL2 = wxNewId();
const long App_ArchivioFrame::ID_STATICTEXT3 = wxNewId();
const long App_ArchivioFrame::ID_TEXTCTRL3 = wxNewId();
const long App_ArchivioFrame::ID_STATICTEXT4 = wxNewId();
const long App_ArchivioFrame::ID_TEXTCTRL4 = wxNewId();
const long App_ArchivioFrame::ID_STATICTEXT5 = wxNewId();
const long App_ArchivioFrame::ID_TEXTCTRL5 = wxNewId();
const long App_ArchivioFrame::ID_BUTTON1 = wxNewId();
const long App_ArchivioFrame::ID_BUTTON2 = wxNewId();
const long App_ArchivioFrame::ID_BUTTON3 = wxNewId();
const long App_ArchivioFrame::ID_BUTTON4 = wxNewId();
const long App_ArchivioFrame::idmenucrea = wxNewId();
const long App_ArchivioFrame::idMenuQuit = wxNewId();
const long App_ArchivioFrame::idMenuAbout = wxNewId();
const long App_ArchivioFrame::ID_STATUSBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(App_ArchivioFrame,wxFrame)
    EVT_MENU(idmenucrea,App_ArchivioFrame::OnCreaFile)

END_EVENT_TABLE()

App_ArchivioFrame::App_ArchivioFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(App_ArchivioFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxGridSizer* GridSizer1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    GridSizer1 = new wxGridSizer(5, 4, 0, 0);
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Nome"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    GridSizer1->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    txtn = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    GridSizer1->Add(txtn, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Cognome"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
    GridSizer1->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    txtcg = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    GridSizer1->Add(txtcg, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Classe"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    GridSizer1->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    txtcl = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    GridSizer1->Add(txtcl, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Sezione"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    GridSizer1->Add(StaticText4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    txts = new wxTextCtrl(this, ID_TEXTCTRL4, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
    GridSizer1->Add(txts, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText5 = new wxStaticText(this, ID_STATICTEXT5, _("Data di Nascita"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT5"));
    GridSizer1->Add(StaticText5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    txtdn = new wxTextCtrl(this, ID_TEXTCTRL5, _("GG/M/AAAA"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
    GridSizer1->Add(txtdn, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    cmdins = new wxButton(this, ID_BUTTON1, _("Inserisci"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    GridSizer1->Add(cmdins, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    cmdannulla = new wxButton(this, ID_BUTTON2, _("Annulla"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    GridSizer1->Add(cmdannulla, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    cmdfine = new wxButton(this, ID_BUTTON3, _("Fine"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
    GridSizer1->Add(cmdfine, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    cmdvis = new wxButton(this, ID_BUTTON4, _("Visualizza DAti"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
    GridSizer1->Add(cmdvis, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    SetSizer(GridSizer1);
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem3 = new wxMenuItem(Menu1, idmenucrea, _("Crea Archivio"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem3);
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    GridSizer1->Fit(this);
    GridSizer1->SetSizeHints(this);

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&App_ArchivioFrame::OncmdinsClick);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&App_ArchivioFrame::OncmdannullaClick);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&App_ArchivioFrame::OncmdfineClick);
    Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&App_ArchivioFrame::OncmdvisClick);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&App_ArchivioFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&App_ArchivioFrame::OnAbout);
    Connect(wxID_ANY,wxEVT_CLOSE_WINDOW,(wxObjectEventFunction)&App_ArchivioFrame::OnClose);
    //*)
    disabilita();
}

App_ArchivioFrame::~App_ArchivioFrame()
{
    //(*Destroy(App_ArchivioFrame)

}


void App_ArchivioFrame::OnQuit(wxCommandEvent& event)
{
    Close();
    exit(0);
}

void App_ArchivioFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}

void App_ArchivioFrame::OnClose(wxCloseEvent& event)
{
    Close(true);
}
void App_ArchivioFrame::OnCreaFile(wxCommandEvent& event)
{
    file.open("archivio.txt",ios::out);
    abilita();
    MenuItem3->Enable(false);
}
void App_ArchivioFrame::azzera()
{
    txtn->SetValue("");
    txtcg->SetValue("");
    txtcl->SetValue("");
    txts->SetValue("");
    txtdn->SetValue("");
}
void App_ArchivioFrame::abilita()
{
    txtn->Enable(true);
    txtcg->Enable(true);
    txtdn->Enable(true);
    txts->Enable(true);
    txtcl->Enable(true);
}
void App_ArchivioFrame::disabilita()
{
    txtn->Enable(false);
    txtcg->Enable(false);
    txtdn->Enable(false);
    txts->Enable(false);
    txtcl->Enable(false);
}
void App_ArchivioFrame::OncmdannullaClick(wxCommandEvent& event)
{
    azzera();
}
void App_ArchivioFrame::OncmdinsClick(wxCommandEvent& event)
{
    wxString temp;
    temp=txtn->GetValue();
    alunno.nome=temp.mb_str();
    temp="";
    temp=txtcg->GetValue();
    alunno.cognome=temp.mb_str();
    temp="";
    txtcl->GetValue();
    alunno.classe=temp.mb_str();
    temp="";
    temp=txts->GetValue();
    alunno.sezione=temp.mb_str();
    temp="";
    temp=txtdn->GetValue();
    alunno.data=temp.mb_str();
    file.write((char*)&alunno,sizeof(alunno));
    file.write((char*)"\n",sizeof(char));
    azzera();
}
void App_ArchivioFrame::OncmdfineClick(wxCommandEvent& event)
{
    file.close();
}

void App_ArchivioFrame::OncmdvisClick(wxCommandEvent& event)
{
}
